
package PINT2;

/*  PINT2:      Java  VB             : 
***************************************************************************************
Izraz = Selekcija
Selekcija = Sekvenca1 | Sekvenca2
Sekvenca1 = "Ponuda", Blanko, Tim , Blanko, "tima:", Blanko, Broj, Blanko, "dinara."
Sekvenca2 = "Java", Blanko, "platforma:", Blanko, JavaPlatforma, Blanko, Kraj
Literal =  Slovo, {Slovo|SpecijalniZnak}
Slovo = "a" | "b" | "v" | ... | Blanko
SpecijalniZnak = : | .| ;
Blanko = " "
Tim = "Java" | "VB"
JavaPlatforma = "J2ME" | "J2SE" | "J2EE"
Kraj ="." | ";"
Broj = Cifra - "0", {Cifra}
Cifra = "0" | "1" | "2" | "3" | "4" | "5" | "6" | "7" | "8" | "9"
***************************************************************************************
Java        (Sekvenc1, Sekvencu2). VB          (Sekvenc1).*/

/*:    ,  ()      .       TerminalExpression (Literal, Selekcija)   NonterminalExpression (Sekvenca)  .
*/
class UpravaFakulteta // Client
 {  SILAB sil;
    ApstraktniIzraz ai;

    UpravaFakulteta(SILAB sil1) {sil = sil1;}
    public static void main(String[] arg)
         {  UpravaFakulteta uf;
            String kontekst1, kontekst2;
            JavaTimPonuda jtp = new JavaTimPonuda();
            VBTimPonuda vtp = new VBTimPonuda();
            //*********************************************************************************************
            uf = new UpravaFakulteta(jtp);
            kontekst1 =  uf.sil.vratiPonudu(1);
            uf.ai = new Sekvenca1();
             if (uf.ai.Interpretiraj(kontekst1)==true)  {System.out.println("Izraz 1: " + kontekst1 + " je regularan izraz.");}
             else  {System.out.println("Izraz 1: " + kontekst1 + " je neregularan izraz.");}
       
             kontekst2 = uf.sil.vratiPonudu(2);
             uf.ai = new Sekvenca2();
             if (uf.ai.Interpretiraj(kontekst2)==true)    {System.out.println("Izraz 2: " + kontekst2 + " je regularan izraz.");}
             else  {System.out.println("Izraz 2: " + kontekst2 + " je neregularan izraz.");}
             //*********************************************************************************************
             uf = new UpravaFakulteta(vtp);
             kontekst1 =  uf.sil.vratiPonudu(1);
             uf.ai = new Sekvenca1();
             if (uf.ai.Interpretiraj(kontekst1)==true) {System.out.println("Izraz 3: " + kontekst1 + " je regularan izraz.");}
             else {System.out.println("Izraz 3: " + kontekst1 + " je neregularan izraz.");}
        }
  }

/*:   (kontekst)           .*/
abstract class SILAB // Context
{ abstract String vratiPonudu(int izraz); }

class JavaTimPonuda extends SILAB
{ @Override
  String vratiPonudu(int izraz)
    {   String kontekst = null;
         if (izraz == 1) kontekst ="Ponuda Java tima: 55000 dinara.";
         if (izraz == 2) kontekst ="Java platforma: J2EE .";
         return kontekst;
    }
}

class VBTimPonuda extends SILAB
{ @Override
  String vratiPonudu(int izraz)
     { String kontekst = null;
        if (izraz == 1) kontekst ="Ponuda VB tima: 45000 dinara.";
        return kontekst;
     }
}

/*:   Interpretiraj(String)           . */
abstract class ApstraktniIzraz // AbstractExpression
{  abstract boolean Interpretiraj(String kontekst);}


class TerminalniIzraz extends ApstraktniIzraz // TerminalExpression
{ @Override
  boolean Interpretiraj(String kontekst){return false;}
}

class NeterminalniIzraz extends ApstraktniIzraz // NonterminalExpression
{ ApstraktniIzraz [] ai;
  @Override
  boolean Interpretiraj(String kontekst){return false;}
}

/*:  Interpretiraj(String)      Literal  () .*/
class Literal extends TerminalniIzraz 
{
  String str;
  Literal(String str1){ str = str1;}

  @Override
  boolean Interpretiraj(String kontekst)
    { boolean simbol = true;
      char niz[] = kontekst.toCharArray();
      for(int i =0; i<niz.length; i++)
        { if (i==0)
             { if (Character.isLetter(niz[i])==false)
                  { simbol = false; System.out.println("Prvi znak nije slovo");return simbol;}
             }
          else
             { if ((Character.isLetter(niz[i])==false) && (niz[i]!=':' &&  niz[i]!='.' && niz[i]!=';'))
	     { simbol = false; System.out.println("Znak: " + niz[i] + " nije slovo ili specijalni znak.");return simbol;}
             }
          }
       if (kontekst.equals(str) == true)  return simbol;
       else   { simbol = false; System.out.println("Kontekst: " + kontekst + " ne odgovara literalu."); return false;}
    }
}

class Blanko extends Literal
{ Blanko () {super(" ");}
  @Override
  boolean Interpretiraj(String kontekst)
      { boolean simbol = true;
        return kontekst.equals(str);
        
    }
}

/*:     ApstraktniIzraz .  Interpretiraj(String)    Sekvenca  ()  . */
class Sekvenca extends NeterminalniIzraz 
{   
    
    @Override
    boolean Interpretiraj(String sek)
        {  String WITH_DELIMITER = "(?<=%1$s)|(?=%1$s)";
           String[] clan = sek.split(String.format(WITH_DELIMITER, " "));
           boolean signal = true; // polazimo od predpostavke da je sekvenca regularna
           for(int i=0;i<clan.length;i++)
	 { System.out.println("Clan[" + i + "]: " +  clan[i]);
	    if (ai[i].Interpretiraj(clan[i])==false)
	             { signal = false;
	               return signal;
	             }
                  }
           return signal;
       }
}

/*            ,     ,      .*/
class Sekvenca1 extends Sekvenca
{ Sekvenca1 ()
     { ai = new ApstraktniIzraz[9];
       ai[0] = new Literal("Ponuda"); ai[1] = new Blanko();  ai[2] = new Tim();
       ai[3] = new Blanko(); ai[4] = new Literal("tima:"); ai[5] = new Blanko();
       ai[6] = new Broj(); ai[7] = new Blanko(); ai[8] = new Literal("dinara.");
     }
}

class Sekvenca2 extends Sekvenca
{ Sekvenca2 ()
   { ai = new ApstraktniIzraz[7];
     ai[0] = new Literal("Java"); ai[1] = new Blanko(); ai[2] = new Literal("platforma:");
     ai[3] = new Blanko(); ai[4] = new JavaPlatforma(); ai[5] = new Blanko(); ai[6] = new Kraj();   
   }
}

/*:  Interpretiraj(String)      Selekcija  () .*/
class Selekcija extends NeterminalniIzraz 
{ String[] element;

  @Override
  boolean Interpretiraj(String tim)
      { boolean signal = false; // predpostavka da ne postoji ni jedan od elemenata.
        for(int i=0;i<element.length;i++)
             if (element[i].equals(tim)==true)
                { signal = true;
	          return signal;
                }
        return signal;
      }
}

class Tim extends Selekcija
{ Tim()
   { element = new String[2];  element[0] = new String("Java");  element[1] = new String("VB"); }
}

class JavaPlatforma extends Selekcija
{ JavaPlatforma()
    { element = new String[3];  element[0] = new String("J2ME"); element[1] = new String("J2SE"); 
      element[2] = new  String("J2EE");
    }
}


class Kraj extends Selekcija
{
  Kraj()
    { element = new String[2]; element[0] = new String(".");  element[1] = new String(";"); }
}

/*:  Interpretiraj(String)      Broj  () .*/
class Broj extends TerminalniIzraz 
{ @Override
  boolean Interpretiraj(String broj)
   { try  { int c = Integer.parseInt(broj);
          }  catch(NumberFormatException nfe)  { return false; }

     return true;
   }
}

